const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const administrationRouteService = require('./administrationRoute.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.get('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new administrationRoute
 * @param {Object} req.body - The administrationRoute data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created administrationRoute
 */
function create(req, res, next) {
    administrationRouteService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all administrationRoutes
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of administrationRoutes
 */
function getAll(req, res, next) {
    administrationRouteService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of administrationRoute objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of administrationRoute objects
 */
function option(req, res, next) {
    administrationRouteService.option(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of administrationRoutes matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of administrationRoutes
 */
function count(req, res, next) {
    administrationRouteService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing administrationRoute
 * @param {number} req.params.id - The administrationRoute ID to be updated
 * @param {Object} req.body - The administrationRoute data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated administrationRoute
 */
function update(req, res, next) {
    administrationRouteService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a administrationRoute
 * @param {number} req.params.id - The administrationRoute ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    administrationRouteService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
